import java.util.*;

class Exercice1 
{
    static Random rnd;
    static Graphe g;

    private static void generatearc(int nb)
    {
	for (int i = 0; i < nb; i++)
	    {
		int s1, s2;
		do {
		    s1 = rnd.nextInt(g.getNbSommet());
		    s2 = rnd.nextInt(g.getNbSommet());
		} while(s1 == s2 || g.est_arc(s1, s2));

		g.ajouter_arc(s1, s2);
	    }
    }

    /*
    public static void main(String[] args)
    {
	g = new GrapheListeChainee(6);
	g.ajouter_arc(0, 1);
	g.ajouter_arc(0, 2);
	g.ajouter_arc(1, 3);
	g.ajouter_arc(1, 4);
	g.ajouter_arc(2, 5);
	LinkedList l = GrapheAlgo.parcours_largeur(g, 0);

    }
    */
    
    public static void main(String[] args)
    {
	int nbsommets = Integer.parseInt(args[0]);
	int nbarcs    = nbsommets*2;
	int total     = 0;
	int nbexp     = Integer.parseInt(args[1]);

	System.out.println("Configuration :");
	System.out.println(" nbsommets = " + nbsommets);
	System.out.println(" nbarcs = " + nbarcs);
	System.out.println(" nbexp = " + nbexp);

	for (int i = 0; i < nbexp; i++)
	    {
		rnd = new Random();
		//		g = new GrapheMatrixNonOriente(nbsommets);
		g = new GrapheListeChainee(nbsommets);
		//g = new GrapheListeChaineeNonOriente(nbsommets);
		generatearc(nbarcs);

		for (int j = 0; j < 100; j++)
		    {
			System.out.print("Session " + i + " Parcours " + j + "\r");
			Date d1 = new Date();
			// GrapheAlgo.parcours_profondeur(g, rnd.nextInt(nbsommets));
			// GrapheAlgo.cfc(g);
			GrapheAlgo.recherche_plus_court_chemin(g, rnd.nextInt(nbsommets));
			Date d2 = new Date();
			total += (d2.getTime()-d1.getTime());
		    }
	    }
	System.out.println("\nTemps : " + (total/(100*nbexp)));
    }
}

